
#ifndef SNIFFY_H
#define SNIFFY_H

#include <linux/tty.h>

typedef void (*ldisc_close_t)(struct tty_struct *tty);
typedef ssize_t (*ldisc_write_t)(struct tty_struct * tty, struct file * file,
                                 const unsigned char * buf, size_t nr);

struct sniffy_term_pid {
	pid_t pid;
#define SF_PID_MAXIDX 250
	int *idx;
	int idxcnt;
	struct hlist_node node;
};

struct sniffy_term {
	unsigned int idx;
	unsigned int group;
	atomic_t refcnt;
	unsigned int seq;

	struct tty_struct *tty_slave;
	struct tty_struct *tty_master;

	ldisc_write_t	ld_write_slave;
	ldisc_write_t	ld_write_master;
	ldisc_close_t   ld_close;

	struct hlist_node node;
};

extern int sniffy_debug;
#define DEBUG1(str) \
do { \
    if (sniffy_debug) \
        printk("sniffy - [%s:%05d] %s\n", __FUNCTION__, __LINE__, str); \
} while(0)

#define DEBUG2(str, ...) \
do { \
    if (sniffy_debug) { \
        printk("sniffy - [%s:%05d] ", __FUNCTION__, __LINE__); \
        printk(str, __VA_ARGS__); \
    } \
} while(0)


#endif // !SNIFFY_H
