
#include <termios.h>
#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <stdio.h>
#include <stdio_ext.h>


#include "config.h"


static struct termios init_settings;

int sf_set_term(int set_init)
{
	struct termios new_settings;
	if (set_init)
		return tcsetattr(0, TCSANOW, &init_settings);

	tcgetattr(0, &init_settings);
	new_settings = init_settings;
	new_settings.c_lflag &= ~ICANON;
	new_settings.c_lflag &= ~ECHO;

	return tcsetattr(0, TCSANOW, &new_settings);
}

int sf_input_init(struct sf_config *cfg, int attach_sf)
{
	if (!cfg->daemon) {
		sf_set_term(0);
		return 0;
	}

	return 0;
}

int sf_input_close(struct sf_config *cfg)
{
	if (!cfg->daemon) {
		sf_set_term(1);
		return 0;
	}

	return 0;
}

int sf_input_process(struct sf_config *cfg)
{
	int c;

	if (!cfg->daemon) {
		c = getchar();

		if (c == '\033') {
			__fpurge(stdin);
			return -1;
		}
	} else {
		if (0 == (c = sf_daemon_process(cfg)))
			return 0;
	}

	return sf_input_cmd_process(cfg, c);
}

int sf_input_print(struct sf_config *cfg, char *str, ...)
{
	va_list ap;
	va_start(ap, str);
	sf_input_cmd_print(cfg, str, ap);
	va_end(ap);
	return 0;
}
